<template>
  <MdTableCell v-bind:class="{'my-cell': true, sortmarked: isSortMarked}"
  >
    <div @click.stop="clicked()"
         v-bind:class="{clickeable: hasClickListener}"
         ref="container"
    >
      <slot>{{defaultValue()}}</slot>
      <MdTooltip v-if="hasClickListener">{{tooltip}}</MdTooltip>
    </div>
  </MdTableCell>
</template>
<script>
/* eslint-disable no-debugger */
import MdTooltip from '../TouchDeviceDisabledTooltip';
import { getInstance } from './TableRegistry';
import i18n from './i18n';
import jsLog from 'js-logger';

const log = jsLog.get('TableColumn');

export default {
  props: {
    sort: {
      type: [Boolean, Function],
      default: false
    },
    field: {
      type: String,
      required: false
    },
    label: {
      type: String,
      required: false
    },
    row: {
      type: Object,
      required: true
    },
    tooltip: {
      type: String
    },
    value: {
      type: Function,
      required: false
    }
  },
  i18n,
  computed:{
    hasClickListener(){
      return this.$listeners && this.$listeners.click && this.tooltip;
    },
    isSortMarked(){
      if(!this.table || !this.table.markSortedColumn) return false;
      return this.table.sortedColumn && this.table.sortedColumn === this.field;
    }
  },
  data(){
    return {
      table: undefined
    }
  },
  components: {
    MdTooltip
  },
  methods: {
    defaultValue(){
      if(this.value){
        return this.value(this.row);
      }
      return this.row[this.field] || '-';
    },
    header(){
      return this.label || this.field;
    },
    clicked(){
      this.$emit('click', this.row.id);
    },
    tableId(){
      let elm = this;
      while(!elm.id) elm = elm.$parent;
      return elm.id;
    }
  },
  created(){
    const clazz = this.$vnode.data.staticClass;
    const col = { label: this.header(), field: this.field, sort: this.sort, value: this.value };
    if (clazz) col.className = clazz;
    const parentId = this.tableId();
    const th = getInstance(parentId);
    log.info('register column', col, parentId);
    th.registerColumn(col, parentId);
    this.table = th;
  },
  beforeUpdate(){
    const col = { label: this.header(), field: this.field, sort: this.sort };
    const parentId = this.tableId();
    const th = getInstance(parentId);
    th.beforeUpdateColumn(col );
  }
};
</script>
<style scoped>
  .clickeable{
    cursor: pointer;
  }
  .sortmarked{
    background-color: var(--table-order-bg-color);
  }
</style>
<style>
  .my-cell > .md-table-cell-container{
    word-break: break-word;
  }
</style>
